commit b272bc0fbf84454cae8c02e7404cfb23641380cd
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Thu Dec 15 09:52:48 2022 +0000

    libstdc++: Fix self-move for std::weak_ptr [PR108118]
    
    I think an alternative fix would be something like:
    
      _M_ptr = std::exchange(rhs._M_ptr, nullptr);
      _M_refcount = std::move(rhs._M_refcount);
    
    The standard's move-and-swap implementation generates smaller code at
    all levels except -O0 and -Og, so it seems simplest to just do what the
    standard says.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/108118
            * include/bits/shared_ptr_base.h (weak_ptr::operator=):
            Implement as move-and-swap exactly as specified in the standard.
            * testsuite/20_util/weak_ptr/cons/self_move.cc: New test.
    
    (cherry picked from commit 92eb0adc14a5f84acce7e5bc780b81b1544b24aa)

diff --git a/libstdc++-v3/include/bits/shared_ptr_base.h b/libstdc++-v3/include/bits/shared_ptr_base.h
index 792d8344664..c66d895997d 100644
--- a/libstdc++-v3/include/bits/shared_ptr_base.h
+++ b/libstdc++-v3/include/bits/shared_ptr_base.h
@@ -1700,9 +1700,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       __weak_ptr&
       operator=(__weak_ptr&& __r) noexcept
       {
-	_M_ptr = __r._M_ptr;
-	_M_refcount = std::move(__r._M_refcount);
-	__r._M_ptr = nullptr;
+	__weak_ptr(std::move(__r)).swap(*this);
 	return *this;
       }
 
diff --git a/libstdc++-v3/testsuite/20_util/weak_ptr/cons/self_move.cc b/libstdc++-v3/testsuite/20_util/weak_ptr/cons/self_move.cc
new file mode 100644
index 00000000000..c890d2ba94d
--- /dev/null
+++ b/libstdc++-v3/testsuite/20_util/weak_ptr/cons/self_move.cc
@@ -0,0 +1,19 @@
+// { dg-do run { target c++11 } }
+
+#include <memory>
+#include <testsuite_hooks.h>
+
+void
+test_self_move()
+{
+  std::shared_ptr<int> sp(new int(66));
+  std::weak_ptr<int> wp(sp);
+  wp = std::move(wp); // PR libstdc++/108118
+  std::shared_ptr<int> sp2(wp);
+  VERIFY(sp2 == sp);
+}
+
+int main()
+{
+  test_self_move();
+}

